#include "yami++.h"
#include <iostream>
#include <string>

using namespace YAMI;
using namespace std;

int main()
{
     netInitialize();
     {
          Agent agent(12340);
          agent.objectRegister("echo",
                    Agent::ePolling, NULL);

          cout << "server started" << endl;
          while (1)
          {
               auto_ptr<IncomingMsg> incoming
                    (agent.getIncoming("echo", true));

               string msgname(incoming->getMsgName());

               if (msgname == "shutdown")
               {
                    cout << "received the shutdown message"
                         << endl;
                    break;
               }
               else // if (msgname == "print")
               {
                    auto_ptr<ParamSet> params
                         (incoming->getParameters());

                    string line;
                    params->getString(0, line);
                    cout << line << endl;
               }
          }
     }
     netCleanup();
     
     return 0;
}
