from YAMI import *

serverhost = '127.0.0.1'
serverport = 12340
clientport = 12341
domainname = 'somDomain'
objectname = 'calculator'

agent = Agent(clientport)
agent.domainRegister(domainname, serverhost, serverport, 2)

msg = agent.send(domainname, objectname, 'add', [100, 20])

msg.wait()

status = msg.getStatus()

if status == eReplied:
    retpar = msg.getResponse()
    result = retpar[0]
    print 'the result is', result
elif status == eRejected:
    print 'the last message was rejected'
else:
    print 'no correct reply'

del msg
del agent
