package require YAMI

set serverhost "127.0.0.1"
set serverport 12340
set clientport 12341
set domainname "someDomain"
set objectname "calculator"

set agent [YAMI::Agent $clientport]
$agent domainRegister $domainname $serverhost $serverport 2

set msg [$agent send $domainname $objectname "add" \
    {{100 i} {20 i}}]

$msg wait

set status [$msg getStatus]
if {$status == "eReplied"} {
    set retpar [$msg getResponse]
    set result [lindex $retpar 0]
    puts "the result is $result"
} elseif {$status == "eRejected"} {
    puts "the last message was rejected"
} else {
    puts "no correct reply"
}

$msg -delete
$agent -delete
