package require YAMI

set serverhost "127.0.0.1"
set serverport 12340
set clientport 12341
set domainname "someDomain"
set objectname "calculator"

puts "starting the client"

set agent [YAMI::Agent $clientport]
$agent domainRegister $domainname $serverhost $serverport 2

while {1} {
    puts -nonewline "please enter the expression (or \'quit\'): "
    flush stdout
    gets stdin str
    if {$str == "quit"} {
        break
    }
    
    if {[scan $str "%d%1s%d" val1 op val2] != 3} {
        puts "wrong expression"
        continue
    }
    
    if {$op == "+"} {
        set msgname "add"
    } elseif {$op == "-"} {
        set msgname "sub"
    } elseif {$op == "*"} {
        set msgname "mul"
    } elseif {$op == "/"} {
        set msgname "div"
    } else {
        puts "wrong expression"
        continue
    }
    
    set msg [$agent send $domainname $objectname $msgname \
        [list [list $val1 i] [list $val2 i]]]
    
    $msg setTimeOut 10
    $msg wait
    
    set status [$msg getStatus]
    if {$status == "eReplied"} {
        set retpar [$msg getResponse]
        set result [lindex $retpar 0]
        puts "$str = $result"
    } elseif {$status == "eRejected"} {
        puts "the last message was rejected"
    } elseif {$statuc == "eTimedOut"} {
        puts "the last message was timed out"
    } else {
        puts "the last message was not replied correctly"
	   $msg -delete
        break;
    }
    
    $msg -delete
}

$agent -delete

puts "thank you!"
