#include "yami++.h"
#include <iostream>
#include <string>

using namespace YAMI;
using namespace std;

int main()
{
     try
     {
          netInitialize();
          {
               Policies policies;
               policies.setHasSender(false);

               Agent agent(12341, policies);
               agent.domainRegister("echoserver",
                    "127.0.0.1", 12340, 2);

               string line;
               while (getline(cin, line))
               {
                    ParamSet params(1);
                    params.setString(0, line);

                    agent.sendOneWay("echoserver",
                         "echo", "print", params);
               }
          }
          netCleanup();
     }
     catch (const exception &e)
     {
          cout << "exception: " << e.what() << endl;
     }

     return 0;
}
