from YAMI import *
import string

serverhost = '127.0.0.1'
serverport = 12340
clientport = 12341
domainname = 'someDomain'
objectname = 'calculator'

print 'starting the client'

agent = Agent(clientport)
agent.domainRegister(domainname, serverhost, serverport, 2)

try:
    while 1:
        str = raw_input('please enter the expression (or\'quit\'): ')
        if str == 'quit':
	       break

        tmp = string.split(str)
        if len(tmp) != 3:
            print 'wrong format'
            continue

        val1 = int(tmp[0])
        op = tmp[1]
        val2 = int(tmp[2])
	   
        if op == '+':
            msgname = 'add'
        elif op == '-':
            msgname = 'sub'
        elif op == '*':
            msgname = 'mul'
        elif op == '/':
            msgname = 'div'
        else:
            print 'wrong expression'
            continue

        msg = agent.send(domainname, objectname, msgname, [val1, val2])
        
        msg.setTimeOut(10)
        msg.wait()
	   
        status = msg.getStatus()
        if status == eReplied:
            retpar = msg.getResponse()
            result = retpar[0]
            print str, ' =', result
        elif status == eRejected:
            print 'the last message was rejected'
        elif status == eTimedOut:
            print 'the last message was timed out'
        else:
            print 'the last message was not replied correctly'
            break

        del msg

except ValueError:
    print 'wrong format'
except:
    pass

del agent

print 'thank you!'
