from YAMI import *

serverport = 12340
objectname = 'calculator'

print 'starting the server'

agent = Agent(serverport)
agent.objectRegister(objectname)

print 'waiting for messages...'

while 1:
    incoming = agent.getIncoming(objectname, 1)
    msgname = incoming.getMsgName()
    
    print 'I have received the message:', msgname
    
    if msgname != 'add' and msgname != 'sub' and \
        msgname != 'mul' and msgname != 'div':
        print 'unknown name - rejecting'
        incoming.reject()
        continue

    params = incoming.getParameters()
    val1 = params[0]
    val2 = params[1]
    
    if msgname == 'add':
        result = val1 + val2
    elif msgname == 'sub':
        result = val1 - val2
    elif msgname == 'mul':
        result = val1 * val2
    else:
        if val2 == 0:
            print 'dividing by 0 not allowed'
            print 'rejecting'
            incoming.reject()
            continue
        else:
            result = val1 / val2

    incoming.reply([result])

    del incoming

del agent
