# This file was created automatically by SWIG
# and later refined by hand

import yamipyc

class Byte:
    def __init__(self,*args):
        self.this = apply(yamipyc.new_Byte,args)
        self.thisown = 1

    def __del__(self,yamipyc=yamipyc):
        if self.thisown == 1 :
            yamipyc.delete_Byte(self)
    def getValue(*args):
        val = apply(yamipyc.Byte_getValue,args)
        return val
    def __repr__(self):
        return "<C Byte instance at %s>" % (self.this,)

class BytePtr(Byte):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
        self.__class__ = Byte

class Binary:
    def __init__(self,*args):
        self.this = apply(yamipyc.new_Binary,args)
        self.thisown = 1

    def __del__(self,yamipyc=yamipyc):
        if self.thisown == 1 :
            yamipyc.delete_Binary(self)
    def getSize(*args):
        val = apply(yamipyc.Binary_getSize,args)
        return val
    def setAt(*args):
        val = apply(yamipyc.Binary_setAt,args)
        return val
    def getAt(*args):
        val = apply(yamipyc.Binary_getAt,args)
        return val
    def set(*args):
        val = apply(yamipyc.Binary_set,args)
        return val
    def get(*args):
        val = apply(yamipyc.Binary_get,args)
        return val
    def __repr__(self):
        return "<C Binary instance at %s>" % (self.this,)

class BinaryPtr(Binary):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
        self.__class__ = Binary

class IncomingMsg:
    def __init__(self,*args):
        self.this = apply(yamipyc.new_IncomingMsg,args)
#        self.thisown = 1

    def __del__(self,yamipyc=yamipyc):
        if self.thisown == 1 :
            yamipyc.delete_IncomingMsg(self)
    def getMsgName(*args):
        val = apply(yamipyc.IncomingMsg_getMsgName,args)
        return val
    def getObjectName(*args):
        val = apply(yamipyc.IncomingMsg_getObjectName,args)
        return val
    def getParameters(*args):
# changed by hand - the IncomingMsg_getParams returns a tuple,
# which first item keeps the values (possibly raw pointers to Byte or Binary)
# and second keeps their types as integers
# this allows to convert raw pointers to shadows
        tup = apply(yamipyc.IncomingMsg_getParameters,args)
        for i in xrange(len(tup[1])):
            if tup[1][i] == 1:
                tup[0][i] = BytePtr(tup[0][i])
                tup[0][i].thisown = 1
            elif tup[1][i] == 2:
                tup[0][i] = BinaryPtr(tup[0][i])
                tup[0][i].thisown = 1
        return tup[0]
    def getLevel(*args):
        val = apply(yamipyc.IncomingMsg_getLevel,args)
        return val
    def reject(*args):
        val = apply(yamipyc.IncomingMsg_reject,args)
        return val
    def reply(*args):
        val = apply(yamipyc.IncomingMsg_reply,args)
        return val
    def forward(*args):
        val = apply(yamipyc.IncomingMsg_forward,args)
        return val
    def forwardAddr(*args):
        val = apply(yamipyc.IncomingMsg_forwardAddr,args)
        return val
    def __repr__(self):
        return "<C IncomingMsg instance at %s>" % (self.this,)

class IncomingMsgPtr(IncomingMsg):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
        self.__class__ = IncomingMsg

class Message:
    def __init__(self,*args):
        self.this = apply(yamipyc.new_Message,args)
#        self.thisown = 1

    def __del__(self,yamipyc=yamipyc):
        if self.thisown == 1 :
            yamipyc.delete_Message(self)
    def setTimeOut(*args):
        val = apply(yamipyc.Message_setTimeOut,args)
        return val
    def getStatus(*args):
        val = apply(yamipyc.Message_getStatus,args)
        return val
    def wait(*args):
        val = apply(yamipyc.Message_wait,args)
        return val
    def getResponse(*args):
# changed by hand - the Message_getResponse returns a tuple,
# which first item keeps the values (possibly raw pointers to Byte or Binary)
# and second keeps their types as integers
# this allows to convert raw pointers to shadows
        tup = apply(yamipyc.Message_getResponse,args)
        for i in xrange(len(tup[1])):
            if tup[1][i] == 1:
                tup[0][i] = BytePtr(tup[0][i])
                tup[0][i].thisown = 1
            elif tup[1][i] == 2:
                tup[0][i] = BinaryPtr(tup[0][i])
                tup[0][i].thisown = 1
        return tup[0]
    def __repr__(self):
        return "<C Message instance at %s>" % (self.this,)

class MessagePtr(Message):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
        self.__class__ = Message

class Policies:
    def __init__(self,*args):
        self.this = apply(yamipyc.new_Policies,args)
        self.thisown = 1

    def __del__(self,yamipyc=yamipyc):
        if self.thisown == 1 :
            yamipyc.delete_Policies(self)
    __setmethods__ = {
        "agentlevel" : yamipyc.Policies_agentlevel_set,
        "objqmaxlength" : yamipyc.Policies_objqmaxlength_set,
        "objqmaxsize" : yamipyc.Policies_objqmaxsize_set,
        "hassender" : yamipyc.Policies_hassender_set,
        "sqmaxlength" : yamipyc.Policies_sqmaxlength_set,
        "sqmaxsize" : yamipyc.Policies_sqmaxsize_set,
        "connpoolsize" : yamipyc.Policies_connpoolsize_set,
        "sendtries" : yamipyc.Policies_sendtries_set,
        "hassocket" : yamipyc.Policies_hassocket_set,
        "reuseaddr" : yamipyc.Policies_reuseaddr_set,
        "haswaker" : yamipyc.Policies_haswaker_set,
    }
    def __setattr__(self,name,value):
        if (name == "this") or (name == "thisown"): self.__dict__[name] = value; return
        method = Policies.__setmethods__.get(name,None)
        if method: return method(self,value)
        self.__dict__[name] = value
    __getmethods__ = {
        "agentlevel" : yamipyc.Policies_agentlevel_get,
        "objqmaxlength" : yamipyc.Policies_objqmaxlength_get,
        "objqmaxsize" : yamipyc.Policies_objqmaxsize_get,
        "hassender" : yamipyc.Policies_hassender_get,
        "sqmaxlength" : yamipyc.Policies_sqmaxlength_get,
        "sqmaxsize" : yamipyc.Policies_sqmaxsize_get,
        "connpoolsize" : yamipyc.Policies_connpoolsize_get,
        "sendtries" : yamipyc.Policies_sendtries_get,
        "hassocket" : yamipyc.Policies_hassocket_get,
        "reuseaddr" : yamipyc.Policies_reuseaddr_get,
        "haswaker" : yamipyc.Policies_haswaker_get,
    }
    def __getattr__(self,name):
        method = Policies.__getmethods__.get(name,None)
        if method: return method(self)
        raise AttributeError,name
    def __repr__(self):
        return "<C Policies instance at %s>" % (self.this,)

class PoliciesPtr(Policies):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
        self.__class__ = Policies

class Agent:
    def __init__(self,*args):
        self.this = apply(yamipyc.new_Agent,args)
        self.thisown = 1

    def __del__(self,yamipyc=yamipyc):
        if self.thisown == 1 :
            yamipyc.delete_Agent(self)
    def domainRegister(*args):
        val = apply(yamipyc.Agent_domainRegister,args)
        return val
    def domainUnregister(*args):
        val = apply(yamipyc.Agent_domainUnregister,args)
        return val
    def objectRegister(*args):
        val = apply(yamipyc.Agent_objectRegister,args)
        return val
    def objectUnregister(*args):
        val = apply(yamipyc.Agent_objectUnregister,args)
        return val
    def send(*args):
        val = apply(yamipyc.Agent_send,args)
        if val: val = MessagePtr(val) ; val.thisown = 1
        return val
    def sendAddr(*args):
        val = apply(yamipyc.Agent_sendAddr,args)
        if val: val = MessagePtr(val) ; val.thisown = 1
        return val
    def sendOneWay(*args):
        val = apply(yamipyc.Agent_sendOneWay,args)
    def sendOneWayAddr(*args):
        val = apply(yamipyc.Agent_sendOneWayAddr,args)
    def getIncoming(*args):
        val = apply(yamipyc.Agent_getIncoming,args)
        if val: val = IncomingMsgPtr(val) ; val.thisown = 1
        return val
    def getLocalAddress(*args):
        val = apply(yamipyc.Agent_getLocalAddress,args)
        return val
    def __repr__(self):
        return "<C Agent instance at %s>" % (self.this,)

class AgentPtr(Agent):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
        self.__class__ = Agent


#-------------- FUNCTION WRAPPERS ------------------

def easySend(*args):
	val = apply(yamipyc.easySend,args)

#-------------- VARIABLE WRAPPERS ------------------

ePosted = yamipyc.ePosted
ePending = yamipyc.ePending
eReplied = yamipyc.eReplied
eRejected = yamipyc.eRejected
eUnknownObj = yamipyc.eUnknownObj
eOverflow = yamipyc.eOverflow
eNetError = yamipyc.eNetError
eTimedOut = yamipyc.eTimedOut
eRejectByAgent = yamipyc.eRejectByAgent
